import React, { useState, useEffect } from 'react';
import {AsyncStorage, ScrollView, Platform, Alert, Picker, Text, TextInput, View, TouchableOpacity, ActivityIndicator } from 'react-native';

import { RouteProp, useNavigation, useRoute } from '@react-navigation/core';
import { RectButton } from 'react-native-gesture-handler';
import { AntDesign, Ionicons } from '@expo/vector-icons';
import { styles } from './styles';
import { Success } from '../../lotties/Success';
import { TextInputMask } from 'react-native-masked-text';
import DateTimePicker from '@react-native-community/datetimepicker';
import { format } from 'date-fns';
import { showMessage, hideMessage } from "react-native-flash-message";

import api from '../../services/api';

type ParamList = {
    Detail: {
        id_reg: string;
        
    };
};


const NovoCliente: React.FC = () => {
    const navigation: any = useNavigation();

    const route = useRoute<RouteProp<ParamList, 'Detail'>>();
    const id_reg = route?.params?.id_reg;
       
    const [nome, setNome] = useState("");
    const [celular, setCelular] = useState("");
    const [endereco, setEndereco] = useState("");
    const [email, setEmail] = useState("");
    const [ativo, setAtivo] = useState("");
    const [pessoa, setPessoa] = useState("Física");
    const [cpf, setCPF] = useState("");
    const [obs, setObs] = useState("");

    const [dataNasc, setdataNasc] = useState(new Date());
    const [show, setShow] = useState(false);

    const onChange = async (event: any, selectedDate: any) => {
        const currentDate = selectedDate || dataNasc;
        setShow(Platform.OS === 'ios');
        setdataNasc(currentDate);
    };
   
    const [sucess, setSucess] = useState(false);
    const [edit, setEdit] = useState(false);
    const [loading, setLoading] = useState(false);
   
    async function saveData() {  
        const user = await AsyncStorage.getItem('@user');     
        const dataNascF = format(dataNasc, 'yyyy-MM-dd');  
        
        if (nome == "" || cpf == "" || email == "") {
            showMessage({
                message: "Erro ao Salvar",
                description: 'Preencha os Campos Obrigatórios!',
                type: "warning",
            });
            return;
        }

        try {
            const obj = {
                id: id_reg,
                nome: nome,
                celular: celular,
                endereco: endereco,
                email: email,
                ativo: ativo,
                pessoa: pessoa,
                cpf: cpf,
                data_nasc: dataNascF,
                obs: obs,
                user: user,
                
            }

            const res = await api.post("api/fornecedores/salvar.php", obj);

            if (res.data.sucesso === false) {
                showMessage({
                    message: "Erro ao Salvar",
                    description: res.data.mensagem,
                    type: "warning",
                    duration: 3000,
                });

                return;
            }

            setSucess(true);
            showMessage({
                message: "Salvo com Sucesso",
                description: "Registro Salvo",
                type: "success",
                duration: 800,
            });
            navigation.push("Fornecedores")

        } catch (error) {
            Alert.alert("Ops", "Alguma coisa deu errado, tente novamente.");
            setSucess(false);
        }
    }

    

    async function loadData() {
        
        try {
            setLoading(true);
            if (id_reg != "0") {
                const res = await api.get(`api/fornecedores/listar_id.php?id=${id_reg}`);

                if (res.data.dados.data_nasc == '0000-00-00') {
                    const dataNasc2 = new Date();
                    setdataNasc(dataNasc2);
                   
                } else {
                    setdataNasc(new Date(res.data.dados.data_nasc + 'T06:00'));
                }
                
                setNome(res.data.dados.nome);
                setCelular(res.data.dados.telefone);
                setEndereco(res.data.dados.endereco);
                setEmail(res.data.dados.email);
                setAtivo(res.data.dados.ativo);
                setCPF(res.data.dados.doc);
                
                setObs(res.data.dados.obs);
                setPessoa(res.data.dados.pessoa);
               
                setEdit(false);
                
            } else {
                setEdit(true);
            }
        } catch (error) {
            console.log('Error ao carregar os Dados');
        }
    }

     
        
    useEffect(() => {
        loadData().then(() => setLoading(false))
    }, [])

    if (loading === true) {
        return (
            <View style={{ flex: 1, backgroundColor: '#fff' }}>
                <ActivityIndicator style={{ marginTop: 100 }} color="#000" size="large" />
            </View>
        )
    }

    if (sucess) {
        return <Success />
    }
    

    return (
        <View style={{ flex: 1, marginTop: 20 }}>
            <View style={styles.Header}>
                <TouchableOpacity
                    style={styles.BackButton}
                    onPress={() => navigation.push("Fornecedores")}
                >
                    <Ionicons name="md-arrow-back-circle-outline" size={35} color="#484a4d" />

                </TouchableOpacity>
                {edit ?
                    <View style={styles.Title}>
                        <Text style={styles.TitleText}>Inserir Registro</Text>
                    </View>

                    :

                    <View style={styles.Title}>
                        <Text style={styles.TitleText}>Editar Registro</Text>
                    </View>
                }

            </View>

             <ScrollView>   
            <View>
                <Text style={styles.TitleInputs}>Nome completo</Text>

                <TextInput
                    placeholder="Nome completo"
                    onChangeText={(text) => setNome(text)}
                    value={nome}
                    style={styles.TextInput}
                />
            </View>


            <View>
                    <Text style={styles.TitleInputs}>Física / Jurídica *</Text>
                    <View style={styles.Picker}>
                        <Picker
                            selectedValue={pessoa}
                            onValueChange={(itemValue, itemIndex) => setPessoa(itemValue)}
                            style={{ color: '#000' }}
                        >
                            <Picker.Item label="Física" value="Física" />
                            <Picker.Item label="Jurídica" value="Jurídica" />

                        </Picker>
                    </View>
                </View>



                <View>
                    <Text style={styles.TitleInputs}>CPF / CNPJ *</Text>

                    {(() => {
                        if (pessoa == 'Física' || pessoa == '') {
                            return (
                                <TextInputMask
                                    style={styles.TextInput}
                                    type={'cpf'}
                                    value={cpf}
                                    onChangeText={text => setCPF(text)}
                                    placeholder="CPF"
                                />
                            )
                        } else {
                            return (
                                <TextInputMask
                                    style={styles.TextInput}
                                    type={'cnpj'}
                                    value={cpf}
                                    onChangeText={text => setCPF(text)}
                                    placeholder="CNPJ"
                                />
                            )
                        }
                    })()}


                </View>

            <View>
                <Text style={styles.TitleInputs}>Celular</Text>

                <TextInputMask
                    style={styles.TextInput}
                    type={'cel-phone'}
                    options={{
                        maskType: 'BRL',
                        withDDD: true,
                        dddMask: '(31) '
                    }}
                    value={celular}
                    onChangeText={text => setCelular(text)}
                    placeholder="Telefone Celular"
                />
            </View>


            <View style={{ flexDirection: 'row', justifyContent: 'space-between', width: '95%', alignSelf: 'center' }}>
            <View style={{ width: '50%' }}>
                        <Text style={styles.TitleInputsRow}>Nascimento</Text>

                        <TouchableOpacity
                            style={styles.pickDate}
                            onPress={() => setShow(true)}
                        >
                            <Text style={styles.date}>{format(dataNasc, 'dd/MM/yyyy')}</Text>
                            <AntDesign style={{ alignSelf: 'center', marginLeft: 25, }} name="caretdown" size={10} color="gray" />
                        </TouchableOpacity>
                    </View>

                    {show && (
                        <DateTimePicker
                            testID="dateTimePicker"
                            value={dataNasc}
                            mode="date"
                            is24Hour={true}
                            display="default"
                            onChange={onChange}
                            
                        />
                    )}




                <View style={{ width: '50%' }}>
                <Text style={styles.TitleInputsRow}>Ativo</Text>
                <View style={styles.Picker}>
                    <Picker
                        selectedValue={ativo}
                        onValueChange={(itemValue, itemIndex) => setAtivo(itemValue)}
                        style={{ color: '#000' }}
                    >
                        <Picker.Item label="Sim" value="Sim" />
                        <Picker.Item label="Não" value="Não" />
                       
                    </Picker>
                </View>
            </View>

            </View>


            <View>
                <Text style={styles.TitleInputs}>Endereço</Text>

                <TextInput
                    placeholder="Rua A Nº 50 Bairro Teste"
                    onChangeText={(text) => setEndereco(text)}
                    value={endereco}
                    style={styles.TextInput}
                   
                />
            </View>

            <View>
                <Text style={styles.TitleInputs}>Email</Text>

                <TextInput
                    placeholder="Email"
                    onChangeText={(text) => setEmail(text)}
                    value={email}
                    style={styles.TextInput}
                   
                />
            </View>

           


            <View>
                    <Text style={styles.TitleInputs}>Observações</Text>

                    <TextInput
                        placeholder="Observações"
                        onChangeText={(text) => setObs(text)}
                        value={obs}
                        style={styles.TextInputArea}
                        multiline={true}
                        numberOfLines={6}
                    />
                </View>

           
                <RectButton
                    style={styles.Button}
                    onPress={() => {
                        setSucess(true);
                        saveData();
                        setSucess(false);
                    }}
                >
                    <Text style={styles.ButtonText}>Salvar Registro</Text>
                </RectButton>

                </ScrollView>

               
            {/* <NewPacientes /> */}

        </View>
    );
}

export default NovoCliente;